.586
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include\masm32\include\masm32.inc
includelib\masm32\lib\masm32.lib
include \masm32\include\user32.inc
includelib \masm32\lib\user32.lib
include \masm32\include\kernel32.inc
includelib \masm32\lib\kernel32.lib
;include \masm32\include\Fpu.inc
;includelib \masm32\lib\Fpu.lib
include \masm32\include\debug.inc
includelib \masm32\lib\debug.lib

WinMain           proto :DWORD,:DWORD,:DWORD,:DWORD
CreateEditBox1    proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
AddReturnLinefeed proto :dword,:dword ;addr Buff1,addr Buff2
AddCounter        proto :dword,:dword ;addr Buff1,addr Buff2
ConvertHexToText  proto :dword,:dword

PrimeCount equ 10000001

.data
ClassName db "PrimeClass",0
EditClassName db "EDIT",0
AppName  db "Prime numbers 2",0
Counter dd 0
HighDWord dd 0 ;address of this variable is used by SetFilePointer. It is the high dubble word of a 64 bit value
ptrBuff1 dd 0 ;Pointer to memory block
FileName1 db "PrimeL001.txt",0
FileName2 db "PrimeL002.txt",0

hFile dd 0
ptrPrimeArray dd 0; Pointer to memory block
BytesWritten dd 0 ;used by WriteFile
BytesWritten2 dd 0 ;The number of bytes in the text buffer
TickCount1 dd 0
TickCount2 dd 0
TickCount3 dd 0
TickCount4 dd 0
TickCount5 dd 0
TickCount6 dd 0
TickCount7 dd 0

Value1 dword 46d3fh
Buff byte 32 dup(0)

.data?
hInstance HINSTANCE ?
hEditInput1 HWND ?
CommandLine LPSTR ?

;Buff2 db 20 dup (?)

.const
IDE_List equ 600 ;Id of the edit box

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	mov    CommandLine,eax
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc


	INVOKE CreateWindowEx,WS_EX_CLIENTEDGE,\
           ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,\
           100,100,265,432,\
           NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax

invoke GlobalAlloc, GMEM_FIXED or GMEM_ZEROINIT, ((4 * PrimeCount) + 16) ;DWords for hex values
mov ptrPrimeArray,eax
invoke GlobalAlloc, GMEM_FIXED or GMEM_ZEROINIT, (24 * PrimeCount) ;Bytes for text values
mov ptrBuff1,eax

invoke GetTickCount
mov TickCount1,eax
call GetPrimes           ;Get all the prime numbers in dword format
invoke GetTickCount
mov TickCount2,eax
call WriteBuff1          ;Convert the dword values from hex to text and add the number for the prime starting at 1
invoke GetTickCount
mov TickCount3,eax
mov edx,0
mov eax,TickCount2
sub eax,TickCount1
PrintDec eax,"Find primes time" ;The time taken to find the dword values
mov edx,0
mov eax,TickCount3
sub eax,TickCount2
PrintDec eax,"Convert and Write Buf1" ;The time taken for the convertion from hex to text + the numbers

invoke GetTickCount
mov TickCount4,eax
invoke CreateFile, addr FileName1, GENERIC_READ OR GENERIC_WRITE, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, FILE_FLAG_RANDOM_ACCESS
mov hFile,eax
invoke WriteFile, hFile, ptrBuff1, BytesWritten2, addr BytesWritten, 0
invoke CloseHandle, hFile
invoke GetTickCount
mov TickCount5,eax
mov edx,0
mov eax,TickCount5
sub eax,TickCount4
PrintDec eax,"Create, write and close file" ;The time taken to open write and close the text file

invoke GetTickCount
mov TickCount6,eax
invoke SetWindowText,hEditInput1,ptrBuff1
invoke GetTickCount
mov TickCount7,eax
mov edx,0
mov eax,TickCount7
sub eax,TickCount6
PrintDec eax,"Write the text to the edit box" ;The time taken to get the text displayed in the edit box



	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	  .IF uMsg==WM_DESTROY             
	       invoke PostQuitMessage,NULL
             invoke GlobalFree, ptrPrimeArray
             invoke GlobalFree, ptrBuff1

        .ELSEIF uMsg==WM_CREATE
            invoke CreateEditBox1, hWnd,0,0,200,330,IDE_List
            mov hEditInput1, eax            
            mov eax,hEditInput1
            invoke SetFocus, eax
       
        .ELSEIF uMsg==WM_COMMAND ;Menu's and controls send WM_COMMAND
        mov eax,wParam ; Menu's and controls have ID's here
            .IF lParam==0 ; Its a menu. Control's will have a handle here
                ; Process the menu that send the WM_COMMAND
                
            .ELSE ; lParam is holding a handle of a control   
                
                                    
            .ENDIF                     
	  .ELSE
	       invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
	   ret
	  .ENDIF
	xor eax,eax

	ret
WndProc endp


;---------------------------------------------------------------------------------------------
CreateEditBox1 proc hParent:DWORD,TopXPos:DWORD,TopYPos:DWORD,Wyd:DWORD,Hoog:DWORD,ID:DWORD
    invoke CreateWindowEx,WS_EX_OVERLAPPEDWINDOW,\
    ADDR EditClassName,0,\
    WS_CHILD OR WS_VISIBLE OR ES_MULTILINE OR WS_VSCROLL,\
    TopXPos,TopYPos,Wyd,Hoog,hParent,ID,\
    hInstance,NULL
    
    ret        
CreateEditBox1 endp

; -------------------------------------------------------------------------
;Write the prime numbers to an dword array and use these prime numbers
; to test if the new possible prime number in eax is a prime or not.
;The value in ebx is used to shorten the list of primes to be tested
; against the value in eax. (A masive speed increase)

GetPrimes proc
        mov edi,ptrPrimeArray
        mov dword ptr[edi+0],2
        mov dword ptr[edi+4],3

        ;mov dword ptr[edi+8],3
        mov eax,5
        add edi,8
        mov ecx,PrimeCount ;5 milion ;Number of prime numbers to get
        sub ecx,1
    NextNumber:
        dec ecx
        jz OutOfHere    
        mov [edi],eax ; [ptrPrimArray+12] = 5 This is the 4th element
        add edi,4 ;edi points to the next open element space
        mov esi,ptrPrimeArray
        add esi,4 ;First useable element. previous numbers 1 2 , is not used
    CheckNextPrime:        
        add eax,2 ;eax = 7,9,11,13,15,17,19,21....
    CheckPrime:
        xor edx,edx ;clear for the division of eax        
        push eax
        div dword ptr[esi] ;divide with array elements ;3,5,7,11,13,17,19,23,29....
        mov ebx,eax ;----------------------------
        cmp edx,0
        jz NotPrime ;If there is no remainder the number was devided into the value in eax
        add esi,4 ;Check the next element
       
        cmp esi,edi 
        je IsPrime ;No other element can be divided into this value without a remaimder
        cmp ebx,dword ptr[esi];----------------------
        jb IsPrime;-----------------------
        pop eax     
        jmp CheckPrime
    NotPrime:
        pop eax
        mov esi,ptrPrimeArray
        add esi,4 ;First useable element. previous number 2, is an even number
        jmp CheckNextPrime
    IsPrime:
        pop eax
        jmp NextNumber
    OutOfHere: 
        
    
    ret
GetPrimes endp 

; -------------------------------------------------------------------------
ConvertHexToText proc uses ebx ecx edx esi edi ptrValue:dword, ptrBuff:dword

; Convert the dword in ptrValue (hex) to readable text in ptrBuff
; Uses eax, ebx, ecx, edx, esi, edi registers
; eax returns the number of bytes written, exluding the terminating zero

	;Text digits are pushed onto the stack

            mov esi,ptrValue
            mov edi,ptrBuff
		mov ebx,0ah ;Devide with 10 decimal. For the convertion
		xor ecx,ecx ;Used for counting the digits
            mov eax,dword ptr[esi]
	GetAnotherDigit:
		xor edx,edx
		div ebx
		add edx,30h ;add 30h to the remainder of the devision to get the text value
		inc ecx
		push edx ;Push onto the stack for storage
		cmp eax,0
		jne GetAnotherDigit
	NoMoreDigits:
;Digits are poped of the stack and stored in ptrBuff
            mov edx,ecx ;make a copy of the number of digits pushed
        MoreTextDigits:
            pop eax
            mov byte ptr [edi],al
            dec edx
            inc edi
            cmp edx,0
            jne MoreTextDigits
            mov byte ptr [edi],0
            mov eax,ecx ;Return the number of digits in eax 
		ret

ConvertHexToText endp

; -------------------------------------------------------------------------
WriteBuff1 proc

        mov Counter,1 ;The number for the prime
        mov esi,ptrPrimeArray
        mov edi,ptrBuff1
        mov ecx, PrimeCount
    WriteAll:
        invoke ConvertHexToText, offset Counter, edi
        add edi,eax
        mov byte ptr [edi],20h
        add edi,1
        invoke ConvertHexToText, esi,edi
        add esi,4
        add edi,eax
        mov word ptr[edi],0a0dh
        add edi,2
        inc Counter
        loop WriteAll
        sub edi,ptrBuff1
        mov BytesWritten2,edi ;Total size of the text in the buffer, including spaces, line feeds and returns
        ret
WriteBuff1 endp

; -------------------------------------------------------------------------


end start